routes/web.php
<?php

use App\Http\Controllers\AssignTaskController;
use App\Http\Controllers\ChangePasswordController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\GrantNewTokenController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\ProjectController;
use App\Http\Controllers\RequestTokenController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\TrashedClientController;
use App\Http\Controllers\TrashedProjectController;
use App\Http\Controllers\TrashedTaskController;
use App\Http\Controllers\TrashedUserController;
use App\Http\Controllers\UnassignTaskController;
use App\Http\Controllers\UpdatePasswordController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;
use Symfony\Component\HttpKernel\Profiler\Profile;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes(['register' => false]);

Route::redirect('/', 'login');

Route::middleware(['guest'])->group(function() {
    Route::controller(ChangePasswordController::class)->prefix('/change-password')->group(function () {
        Route::get('/{token}', 'create')->name('change-password.create');
        Route::post('/', 'store')->name('change-password.store');
    });

    Route::controller(RequestTokenController::class)->prefix('/request-token')->group(function () {
        Route::get('/{token}', 'create')->name('request-token.create');
        Route::post('/', 'store')->name('request-token.store');
    });
});


Route::middleware(['auth', 'password_not_changed'])->group(function (){
    Route::get('/dashboard', DashboardController::class)->name('dashboard');
    Route::post('/new_password', [UpdatePasswordController::class, 'store'])->name('new-password.store');

    Route::controller(ProfileController::class)->prefix('/profiles/{user}')->group(function (){
        Route::get('/', 'show')->name('profiles.show');
        Route::get('/edit', 'edit')->name('profiles.edit');
        Route::put('/', 'update')->name('profiles.update');
    });

    Route::resource('users', UserController::class);
    Route::patch('/users/{user}/restore', [UserController::class, 'restore'])->withTrashed()->name('users.restore');
    Route::post('users/{user}/token', GrantNewTokenController::class)->name('users.new-token');

    Route::resource('clients', ClientController::class);
    Route::patch('/clients/{client}/restore', [ClientController::class, 'restore'])->withTrashed()->name('clients.restore');
    Route::patch('/clients/{client}/forcedelete', [ClientController::class, 'forceDelete'])->withTrashed()->name('clients.force-delete');
    
    Route::resource('projects', ProjectController::class);
    Route::patch('/projects/{project}/restore', [ProjectController::class, 'restore'])->withTrashed()->name('projects.restore');
    Route::patch('/projects/{project}/forcedelete', [ProjectController::class, 'forceDelete'])->withTrashed()->name('projects.force-delete');

    Route::resource('tasks', TaskController::class);
    Route::patch('/tasks/{task}/restore', [TaskController::class, 'restore'])->withTrashed()->name('tasks.restore');
    Route::patch('/tasks/{task}/forcedelete', [TaskController::class, 'forceDelete'])->withTrashed()->name('tasks.force-delete');
    Route::patch('/tasks/{task}/unassign', UnassignTaskController::class)->name('tasks.unassign');
    Route::patch('/tasks/{task}/assign', AssignTaskController::class)->name('tasks.self-assign');

    Route::get('/trashed/projects', TrashedProjectController::class)->name('projects.trashed');
    Route::get('/trashed/clients', TrashedClientController::class)->name('clients.trashed');
    Route::get('/trashed/tasks', TrashedTaskController::class)->name('tasks.trashed');
    Route::get('/trashed/users', TrashedUserController::class)->name('users.trashed');
});

app/Models/Client.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;
use Spatie\Activitylog\LogOptions;
use Spatie\Activitylog\Traits\LogsActivity;

class Client extends Model
{
    use HasFactory, SoftDeletes, LogsActivity;

    protected $fillable = [
        'company_name', 'company_address', 'company_zip', 'company_city',
        'company_country', 'contact_name', 'contact_email', 'contact_phone'
    ];

    protected $hidden = ['deleted_at'];

    public static function booted()
    {
        static::deleting( function (Client $client) {
            $client->projects()->delete();
        });
    }

    public function projects(): HasMany
    {
        return $this->hasMany(Project::class);
    }

    public function getActivitylogOptions(): LogOptions
    {
        return LogOptions::defaults()
            ->logFillable()
            ->logOnlyDirty();
    }
}

app/Http/Controllers/Api/ClientController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Http\Resources\ClientResource;
use App\Models\Client;
use Illuminate\Http\Request;
use App\Http\Requests\ClientRequest;
use Symfony\Component\HttpFoundation\Response;

class ClientController extends Controller
{
    public function __construct()
    {
        $this->middleware(['permission:create_client'])->only('store');
        $this->middleware(['permission:edit_client'])->only('update');
        $this->middleware(['permission:delete_client'])->only('destroy');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $clients = Client::paginate(10);
        return ClientResource::collection($clients);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ClientRequest $request)
    {
        $client = Client::create($request->validated());

        // return (new ClientResource($client))->response(Response::HTTP_CREATED);
        return response()->json(new ClientResource($client), Response::HTTP_CREATED);
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Client  $client
     * @return \Illuminate\Http\Response
     */
    public function show(Client $client)
    {
        $client->load('projects', 'projects.status', 'projects.manager');

        return new ClientResource($client);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Client  $client
     * @return \Illuminate\Http\Response
     */
    public function update(ClientRequest $request, Client $client)
    {
        $client->update($request->validated());

        return (new ClientResource($client))->response(Response::HTTP_OK);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Client  $client
     * @return \Illuminate\Http\Response
     */
    public function destroy(Client $client)
    {
        $client->delete($client);

        return response([], Response::HTTP_NO_CONTENT);
    }
}

app/Http/Controllers/ClientController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ClientRequest;
use App\Models\Client;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Response;
use Illuminate\View\View;


class ClientController extends Controller
{

    public function __construct()
    {
        $this->authorizeResource(Client::class, 'client');
    }

    /**
     * Display a listing of the resource.
     *
     * @return View
     */
    public function index(): View
    {
        $builder = Client::query();

        if ($search = request()->get('search')) {
            $builder->where('company_name', 'LIKE', '%'.$search.'%')
                ->orWhere('contact_name', 'LIKE', '%'.$search.'%');
        }

        $clients = $builder->paginate(10);

        return view('clients.index', compact('clients', 'search'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create(): View
    {
        return view('clients.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param ClientRequest $request
     * @return RedirectResponse
     */
    public function store(ClientRequest $request): RedirectResponse
    {
        Client::create($request->validated());

        return redirect()->route('clients.index')
            ->with('success', 'The client has been created.');
    }

    /**
     * Display the specified resource.
     *
     * @param Client $client
     * @return View
     */
    public function show(Client $client): View
    {
        $projects = $client->projects()->with('manager', 'status')->paginate(10);

        return view('clients.show', compact('client', 'projects'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Client $client
     * @return View
     */
    public function edit(Client $client): View
    {
        return view('clients.edit', compact('client'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param ClientRequest $request
     * @param Client $client
     * @return RedirectResponse
     */
    public function update(ClientRequest $request, Client $client): RedirectResponse
    {
        $client->update($request->validated());

        return redirect()->route('clients.show', $client)
            ->with('success', 'The client has been updated.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Client $client
     * @return RedirectResponse
     */
    public function destroy(Client $client): RedirectResponse
    {
        $client->delete();

        return redirect()->route('clients.index')
            ->with('success', 'The client has been deleted.');
    }

    public function restore(Client $client): RedirectResponse
    {
        $this->authorize('restore', $client);

        $client->restore();

        return redirect()->route('clients.trashed')
            ->with('success', 'The client has been restored!');
    }

    public function forceDelete(Client $client): RedirectResponse
    {
        $this->authorize('forceDelete', $client);

        $client->forceDelete();
        return redirect()->route('clients.trashed')
            ->with('success', 'The client has been permanently deleted.');
    }
}

resources/views/clients/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <h1 class="card-title text-capitalize">New Client</h1>
                    </div>

                    <div class="card-body">
                        <x-errors :errors="$errors" />

                        <form action="{{ route('clients.store') }}" method="POST">
                            @csrf
                            <h3 class="card-subtitle text-capitalize">
                                Company Information
                            </h3>

                            <div class="mt-2">
                                <div class="form-group">
                                    <label class="form-label" for="company_name">Company name</label>
                                    <input 
                                        type="text" 
                                        id="company_name" 
                                        name="company_name"
                                        class="form-control @error('company_name') is-invalid @enderror"
                                        value="{{ old('company_name') }}">
                                </div>

                                <div class="row mt-2">
                                    <div class="col">
                                        <div class="form-group">
                                            <label class="form-label" for="company_address">Company address</label>
                                            <input 
                                                type="text" 
                                                id="company_address" 
                                                name="company_address"
                                                class="form-control @error('company_address') is-invalid @enderror"
                                                value="{{ old('company_address') }}">
                                        </div>
                                    </div>

                                    <div class="col">
                                        <div class="form-group">
                                            <label class="form-label" for="company_zip">Postcode</label>
                                            <input 
                                                type="text" 
                                                id="company_zip" 
                                                name="company_zip"
                                                class="form-control @error('company_zip') is-invalid @enderror"
                                                value="{{ old('company_zip') }}">
                                        </div>
                                    </div>
                                </div>

                                <div class="row mt-2">
                                    <div class="col">
                                        <div class="form-group">
                                            <label class="form-label" for="company_city">City</label>
                                            <input 
                                                type="text" 
                                                id="company_city" 
                                                name="company_city"
                                                class="form-control @error('company_city') is-invalid @enderror"
                                                value="{{ old('company_city') }}">
                                        </div>
                                    </div>

                                    <div class="col">
                                        <div class="form-group">
                                            <label class="form-label" for="company_country">Country</label>
                                            <input 
                                                type="text" 
                                                id="company_country" 
                                                name="company_country"
                                                class="form-control @error('company_country') is-invalid @enderror"
                                                value="{{ old('company_country') }}">
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <hr>
                            <h3 class="card-title mt-2">
                                Contact information
                            </h3>

                            <div class="row mt-2">
                                <div class="col">
                                    <div class="form-group">
                                        <label class="form-label" for="contact_name">Name</label>
                                        <input 
                                            type="text" 
                                            id="contact_name" 
                                            name="contact_name"
                                            class="form-control @error('contact_name') is-invalid @enderror"
                                            value="{{ old('contact_name') }}">
                                    </div>
                                </div>

                                <div class="col">
                                    <div class="form-group">
                                        <label class="form-label" for="contact_email">Email</label>
                                        <input 
                                            type="email" 
                                            id="contact_email" 
                                            name="contact_email"
                                            class="form-control @error('contact_email') is-invalid @enderror"
                                            value="{{ old('contact_email') }}">
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-6 mt-2">
                                <div class="form-group">
                                    <label class="form-label" for="contact_phone">Phone number</label>
                                    <input 
                                        type="text" 
                                        id="contact_phone" 
                                        name="contact_phone"
                                        class="form-control @error('contact_phone') is-invalid @enderror"
                                        value="{{ old('contact_phone') }}">
                                </div>
                            </div>

                            <div class="form-group mt-2">
                                <div class="d-flex justify-content-end">
                                    <a href="{{ route('clients.index') }}" class="btn btn-outline-info text-capitalize me-2">
                                        Cancel
                                    </a>
                                    <input type="submit" class="btn btn-success text-white fw-semibold" value="Create">
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/clients/edit.blade.php
  @extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <div class="mb-2">
                <a href="{{ route('clients.show', $client) }}" class="btn btn-ghost-info text-capitalize">
                    &#xab; Return to client page
                </a>
            </div>

            <div class="card">
                <div class="card-header">
                    <h1 class="card-title">{{ $client->company_name }}</h1>
                </div>

                <div class="card-body">
                    <x-errors :errors="$errors" />

                    <form action="{{ route('clients.update', $client) }}" method="POST">
                        @csrf
                        @method('PUT')

                        <h3 class="card-subtitle text-capitalize">
                            Company Information
                        </h3>

                        <div class="form-group mt-2">
                            <label class="form-label" for="company_name">Company name</label>
                            <input 
                                type="text" 
                                id="company_name" 
                                name="company_name"
                                class="form-control @error('company_name') is-invalid @enderror"
                                value="{{ old('company_name', $client->company_name) }}">
                        </div>

                        <div class="row mt-2">
                            <div class="col">
                                <div class="form-group">
                                    <label for="company-address" class="form-label">Company address</label>
                                    <input 
                                        type="text" 
                                        id="company_address" 
                                        name="company_address"
                                        class="form-control @error('company_address') is-invalid @enderror"
                                        value="{{ old('company_address', $client->company_address) }}">
                                </div>
                            </div>

                            <div class="col">
                                <div class="form-group">
                                    <div class="form-group">
                                        <label class="form-label" for="company_zip">Postcode</label>
                                        <input 
                                            type="text" 
                                            id="company_zip" 
                                            name="company_zip"
                                            class="form-control @error('company_zip') is-invalid @enderror"
                                            value="{{ old('company_zip', $client->company_zip) }}">
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="row mt-2">
                            <div class="col">
                                <div class="form-group">
                                    <label class="form-label" for="company_city">City</label>
                                    <input 
                                        type="text" 
                                        id="company_city" 
                                        name="company_city"
                                        class="form-control @error('company_city') is-invalid @enderror"
                                        value="{{ old('company_city', $client->company_city) }}">
                                </div>
                            </div>

                            <div class="col">
                                <div class="form-group">
                                    <label class="form-label" for="company_country">Country</label>
                                    <input 
                                        type="text" 
                                        id="company_country" 
                                        name="company_country"
                                        class="form-control @error('company_country') is-invalid @enderror"
                                        value="{{ old('company_country', $client->company_country) }}">
                                </div>
                            </div>
                        </div>

                        <hr>

                        <h3 class="card-title mt-2 text-capitalize">Contact Information</h3>
                        <div class="row mt-2">
                            <div class="col">
                                <div class="form-group">
                                    <div class="form-group">
                                        <label class="form-label" for="contact_name">Name</label>
                                        <input 
                                            type="text" 
                                            id="contact_name" 
                                            name="contact_name"
                                            class="form-control @error('contact_name') is-invalid @enderror"
                                            value="{{ old('contact_name', $client->contact_name) }}">
                                    </div>
                                </div>
                            </div>

                            <div class="col">
                                <div class="form-group">
                                    <label class="form-label" for="contact_email">Email</label>
                                    <input 
                                        type="email" 
                                        id="contact_email" 
                                        name="contact_email"
                                        class="form-control @error('contact_email') is-invalid @enderror"
                                        value="{{ old('contact_email', $client->contact_email) }}">
                                </div>
                            </div>
                        </div>

                        <div class="col-md-6 mt-2">
                            <div class="form-group">
                                <label class="form-label" for="contact_phone">Phone number</label>
                                <input 
                                    type="text" 
                                    id="contact_phone" 
                                    name="contact_phone"
                                    class="form-control @error('contact_phone') is-invalid @enderror"
                                    value="{{ old('contact_phone', $client->contact_phone) }}">
                            </div>
                        </div>

                        <div class="form-group mt-2">
                            <div class="d-flex justify-content-end">
                                <a href="{{ route('clients.show', $client) }}" class="btn btn-outline-info text-capitalize me-2">
                                    Cancel
                                </a>
                                <input type="submit" class="btn btn-success text-white fw-semibold" value="Update">
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/clients/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <x-flash-success :message="session('success')"/>

                <div class="card">
                    <div class="card-header">
                        <div class="row align-items-center mb-1">
                            <div class="col-md-4">
                                <h1 class="card-title ms-2">Clients</h1>
                            </div>
                            <div class="col-md-4">
                                <x-search :action="route('clients.index')" :search="$search" placeholder="search by company name or contact"/>
                            </div>
                            <div class="col-md-4">
                                <div class="d-flex justify-content-end me-2">
                                    @can('create_client')
                                        <a href="{{ route('clients.create') }}" class="btn btn-success text-white fw-semibold rounded me-2 text-capitalize">
                                            New client
                                        </a>
                                    @endcan
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="card-body">
                        @if(!$clients->count())
                            <p>No clients yet.</p>
                        @else
                            <table class="table table-responive-sm table-striped table-hover">
                                <thead>
                                <tr>
                                    <th>Company</th>
                                    <th>Contact</th>
                                    <th>Address</th>
                                    <th>City</th>
                                    <th>Country</th>
                                    @if(auth()->user()->can('edit_client') || auth()->user()->can('delete_client'))
                                        <th>Actions</th>
                                    @endif
                                </tr>
                                </thead>
                                <tbody>
                                    @foreach ($clients as $client)
                                        <tr>
                                            <x-table-link route="clients.show" :param="$client" :routeName="$client->company_name"/>
                                            <td>{{ $client->contact_name }}</td>
                                            <td>{{ $client->company_address }}</td>
                                            <td>{{ $client->company_city }}</td>
                                            <td>{{ $client->company_country }}</td>

                                        @if(auth()->user()->can('edit_client') || auth()->user()->can('delete_client'))
                                            <td class="d-flex align-items-center">
                                                @can('edit_client')
                                                    <a class="btn btn-sm btn-info fw-semibold text-capitalize"
                                                       href="{{ route('clients.edit', $client) }}">
                                                        Edit
                                                    </a>
                                                @endcan

                                                @can('delete_client')
                                                    <form action="{{ route('clients.destroy', $client) }}" method="POST" onsubmit="return confirm('Are you sure you want to delete this client?');">
                                                        @csrf
                                                        @method('DELETE')
                                                        <input type="submit" class="btn btn-sm btn-danger text-white fw-semibold ms-2 text-capitalize" value="Delete">
                                                    </form>
                                                @endcan
                                            </td>
                                        @endif
                                    </tr>
                                @endforeach
                                </tbody>
                            </table>

                            <div class="d-flex justify-content-between align-items-center clearfix">
                                <div class="pl-2">
                                    <span class="fw-semibold">
                                        {{ $clients->count() }} out of {{ $clients->total() }} clients
                                    </span>
                                </div>
                                <div class="justify-content-start">
                                    {{ $clients->links() }}
                                </div>
                            </div>
                        @endif
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection